Last Comment Bug 298271 - Disable quadruple-click (quad-click) paragraph selection on the 1.8 branch
: Disable quadruple-click (quad-click) paragraph selection on the 1.8 branch
Status: RESOLVED FIXED
: fixed1.8, useless-UI
Product: Core
Classification: Components
Component: Selection (show other bugs)
: Trunk
: PowerPC Mac OS X
: -- normal (vote)
: ---
Assigned To: Uri Bernstein (Google)
:
Mentors:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2005-06-20 13:48 PDT by Uri Bernstein (Google)
Modified: 2005-08-22 16:55 PDT (History)
4 users (show)
brendan: blocking1.8b5+
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments
patch (730 bytes, patch)
2005-06-25 12:35 PDT, Uri Bernstein (Google)
roc: review+
roc: superreview+
brendan: approval1.8b4+
Details | Diff | Splinter Review

Description Uri Bernstein (Google) 2005-06-20 13:48:43 PDT
Currently, quadruple-click (on Mac, and possibly on Linux) attempts to select a
paragraph.
(http://bonsai.mozilla.org/cvsblame.cgi?file=/mozilla/layout/generic/nsFrame.cpp&rev=3.565#1581)
Sadly, the paragraph-selection code is completely broken, so usually just the
current line is selected, but in some situations (such as in bugzilla comments),
the current and previous lines are selected. This is confusing and unhelpful.

If and when the paragraph-selection code is fixed, it would probably be assigned
to triple-click (see bug 32807). For now, quadruple click should simply be disabled.

This is not an issue on Windows because the OS apparently does not pass on
n-click events (where n>2) to the application.
Comment 1 Uri Bernstein (Google) 2005-06-25 12:35:17 PDT
Created attachment 187300 [details] [diff] [review]
patch

Disable quad-click. The very broken paragraph selection feature is still
accessable by setting browser.triple_click_selects_paragraph.
Comment 2 Robert O'Callahan (:roc) (Exited; email my personal email if necessary) 2005-06-26 21:35:33 PDT
I don't think we should disable this. If we disable it, it's less likely to ever
be fixed. And I'm not aware of any evidence that this is a significant problem.
Are you?

I think the right way to proceed is to fix paragraph selection and then in bug
32807 we may or may not decide to change the UI behavior.
Comment 3 Uri Bernstein (Google) 2005-06-26 23:16:20 PDT
It's not a *significant* problem, but it's certainly noticable.
I totally agree that in the long run paragraph selection should be fixed (and I
even think it should be the default behaviour for triple-click). I'll even
probably try to fix it myself sometime. However,  I don't see this being fixed
for Firefox 1.1, and having quad-click behave like it does now is certainly
worse than nothing at all. I don't think disabling this will have much of an
effect on the chances for fixing paragraph selection (Windows users, still the
vast majority, can't use quad-click anyway).

Perhaps we should wait for the Forefox 1.1 branch, and then disable quad-click
on the branch only (and work on fixing paragraph selection on the trunk)?
Comment 4 Uri Bernstein (Google) 2005-06-26 23:19:20 PDT
(In reply to comment #3)
> It's not a *significant* problem, but it's certainly noticable.

What I meant to write was:
It's not a *major* problem, but it's certainly noticable. (I gues that makes it
siginificant).
Comment 5 Benjamin Smedberg [:bsmedberg] 2005-06-28 14:03:31 PDT
Comment on attachment 187300 [details] [diff] [review]
patch

Please do not request approval until reviews are complete.
Comment 6 Robert O'Callahan (:roc) (Exited; email my personal email if necessary) 2005-06-29 16:45:13 PDT
Comment on attachment 187300 [details] [diff] [review]
patch

this is approved for branch only. Don't land it on the trunk, but you can land
it on the 1.8 branch once it's been created (and you have approval)
Comment 7 Uri Bernstein (Google) 2005-08-13 02:24:25 PDT
Comment on attachment 187300 [details] [diff] [review]
patch

Requesting approval1.8b4: This is a branch-specific fix with minimal risk. It
disables a UI (quad-click) to a feature which is broken to the point of being
useless.
Comment 8 David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch) 2005-08-13 02:30:36 PDT
FWIW, clicking the mouse rapidly (within the double-click interval) gives the
following sequences of click counts:
  Windows: 1 2 3 2 3 2 3 2 3 ...
  GTK:     1 2 3 1 2 3 1 2 3 ...
  Mac:     1 2 3 4 5 6 7 8 9 ...
Comment 9 David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch) 2005-08-13 02:36:44 PDT
Did this work better in the past?  Or has it always been this broken?  Is it
broken to the point of not being useful?
Comment 10 Uri Bernstein (Google) 2005-08-13 02:52:34 PDT
(In reply to comment #9)
> Did this work better in the past?  Or has it always been this broken?  Is it
> broken to the point of not being useful?

See bug 32807 for the history of paragraph-selection. As far as I understand,
this never worked properly. I'm currently working on making it work (for 1.9) -
you can see my WIP patches on that bug.

The brokenness is described in comment #0: It usually just selects the line
(i.e., behaves just like triple-click), but in some cases also selects the
previous line (which makes no sense). I havent seen a case where it actually
works (i.e. selects a paragraph).
Comment 11 Brendan Eich [:brendan] 2005-08-22 16:18:30 PDT
Comment on attachment 187300 [details] [diff] [review]
patch

Fix the comment typo and a=drivers for 1.8b4.

/be
Comment 12 Brendan Eich [:brendan] 2005-08-22 16:19:46 PDT
Please remember to nominate the bug before or at the same time you nominate a
patch attached to the bug.  This helps us measure how well we're doing at bug
fixing more easily.  Thanks,

/be
Comment 13 Blake Kaplan (:mrbkap) 2005-08-22 16:55:37 PDT
Fix checked into MOZILLA_1_8_BRANCH only, marking this as fixed since it's a
branch-only sort of bug.

Checking in layout/generic/nsFrame.cpp;
/cvsroot/mozilla/layout/generic/nsFrame.cpp,v  <--  nsFrame.cpp
new revision: 3.574.2.1; previous revision: 3.574
done

Note You need to log in before you can comment on or make changes to this bug.